Summary: David's LaTeX to HTML translator
Name: dlh
Version: 0.7d
Release: 1
Copyright: GPL
Group: Applications/Text
Source: dlh-0.7d.tar.gz
Patch: dlh-0.7d-fix.patch
BuildRoot: /tmp/dlh

%description
This is dlh---a fast LaTeX to HTML translator.  Some people say it is
an express delivery service with a twist, others claim it stands for
David's LaTeX to HTML translator.  Take your pick.

1998-04-01	Hugo van der Kooij <hvdkooij@caiw.nl>
	* Made the missing SPEC file

1998-01-21  David Mosberger-Tang  <David.Mosberger@acm.org>

	* Version 0.7d released.

	* lib/Makefile.am (noinst_LIBRARIES): rename to libextra.a to
	conform with automake rules.

	* src/Makefile.am (LDADD): Use automake conditional facility
	instead of GNU make conditionals.

	* configure.in: Declare INCLUDED_LIBINTL as a automake
	conditional.

1997-11-12  David Mosberger-Tang  <David.Mosberger@acm.org>

	* src/dlh.c (make_current_section_number_string): Don't generate
	section numbers deeper than \subsubsection{}s.
	(NUMBERED_LEVELS): New macro defining number of section levels
	that get numbered.
	(gen_section_header): Don't do anything fancy for section names
	that are nested deeper than NUMBERED_LEVELS.  I.e., don't create a
	named tag and don't add it to the TOC.

1997-11-10  David Mosberger-Tang  <David.Mosberger@acm.org>

	* src/dlh.c (cmd_env_end): Ignore closing of environments that are
	known to be unknown & pop environment only for \end{} commands
	that match the name of the currently active environment.

1997-11-07  David Mosberger-Tang  <David.Mosberger@acm.org>

	* src/dlh.c (cmd_psfig): Fix typo: width is supposed to
	be bb[2] - bb[0], not bb[1] - bb[0].
	(environ_list): Make sloppypar an ignored environment.

1997-11-05  David Mosberger-Tang  <David.Mosberger@acm.org>

	* dlh-inputs/comment.sty: New file, based on Ed Bailey's
	suggestion.

1997-07-08  David Mosberger-Tang  <davidm@azstarnet.com>

	* Version 0.7c released.

	* src/dlh_math.c (cmd_math_nonumber): New function.
	(cmd_math_line_break): Ditto

	* src/dlh_math.c (math_list): Add \nonumber.

	* src/dlh.c (cmd_list): Add \quad, \qquad.

	* src/dlh.c (cmd_line_break): Add tabbing support.
	(cmd_tab_move): New function.
	(cmd_kill): Ditto.
	(accented_char): New function.

	* src/dlh_math.c (math_list): New commands: \Leftarrow,
	\leftarrow, \Rightarrow, \emptyset, \ge, \geq, \gg, \langle, \le,
	\leftarrow, \leq, \ll, \mathbf, \mathcal, \mathit, \mathrm,
	\mathsf, \mathtt, \mu, \rangle, \rightarrow, \times, \wedge.

	* src/dlh_math.c (env_eqnarray): New function.
	* src/dlh_math.c (env_equation): Delete.

	* src/dlh.c (cmd_list): Added \sloppy (no-op), \vdots.

	* dlh-inputs/html.sty: Define latexonly as alias for comment
	environment.

	* src/dlh.c (environ_list): Implement flushleft and flushright
	using <div align=...> </div>.
	(cmd_DLHskipto): New function.
	(cmd_list): New command \DLHskipto{}.

Sun Jun  1 14:12:50 1997  David Mosberger-Tang  <davidm@azstarnet.com>

	* src/dlh.c (locate_and_open): New function.
	(open_file): Use locate_and_open().
	(cmd_psfig): Use locate_and_open() to find the full path of the
	PS source file so we can tell gs where to look for it.

	* src/dlh.h (push_env): Declare.

	* src/dlh.c (open_file): Operate on copy of SEARCH_PATH to avoid
	problems with strsep() changing the string.
	(open_file): Initialize fd with -1 to keep gcc quiet.
	(cmd_eval_and_emit): Remove (unused).
	(cmd_psfig): Use texinputs search-path (as LaTeX does).
	(cmd_section): Initialize toc_entry to 0 to keep gcc quiet.
	(cmd_bibliography): Delete unused variable buf;
	(reset_math_mode): Remove (unused).
	(cmd_usepackage): Delete unused variable end.
	(to_roman): Make "static void" (from "char *").
	(to_roman): Delete unused variable i.

Sun Mar 16 10:34:23 1997  David Mosberger-Tang  <davidm@azstarnet.com>

	* src/dlh.c (main): Handle options -l (--split-level) and -r
 	(--resolution).
	(opts): Add entry for "resolution" and "split-level".
	(DEFAULT_DISPLAY_DPI): Rename from DISPLAY_DPI.
	(display_dpi): New variable.
	(cmd_psfig): Use variable display_dpi instead of DISPLAY_DPI
 	macro.

Mon Feb 10 10:02:00 1997  David Mosberger-Tang  <davidm@azstarnet.com>

	* src/dlh.c: \cline{} has one required argument.

	* inputs/html.sty: Change \url so it simply typesets the argument
	in \texttt.  The HTML version is now in dlh-inputs/html.sty.

Sat Feb  1 00:16:39 1997  David Mosberger-Tang  <davidm@azstarnet.com>

	* src/dlh.c (cmd_list): Add \addvspace (ignored), \newcounter,
 	\setcounter, \addtocounter, \stepcounter, \refstepcounter, \value,
 	\arabic, \Roman, \roman, \alph, \Alph, \fnsymbol.
	(cmd_newcounter): New function.
	(cmd_inc_counter): Ditto.
	(reset_children): Ditto.
	(cmd_stepcounter): Ditto.
	(to_roman): Ditto.
	(cmd_value): Ditto.
	(cmd_list): Add \hrule, \linebreak, \fbox (lossage), \raggedright
 	(lossage).

Fri Jan 31 18:53:12 1997  David Mosberger-Tang  <davidm@azstarnet.com>

	* src/dlh.h (ARG_REQ1_OPT1): New macro.

	* src/dlh.c: Make xref enter an index instead of a pointer since
 	the returned pointer value is not meaningful (for a long time).
	(env_thebibliography): Fix typo.
	(section_file_mask): New variable to keep track of which section
	levels have an an output file associated.
	(cmd_section): Use section_file_mask to determine whether a
	file should be popped and update mask when pushing a file.
	(inside_comment): New variable.
	(cmd_list): Added \flushbottom, \raggedbottom, and
	\pagenumbering (all ignored).  Added \copyright.
	

	* src/dlh.h (struct xref_use): Make member def an index, not a
 	pointer (since the array base may be realloc()ed).

	* src/dlh.c: Added bfseries, mdseries environments.  rmfamily,
 	ttfamily, sffamily, upshape, itshape, slshape, scshape.
	(cmd_section): Check for file stack underflow.

Tue Jan 28 14:22:03 1997  David Mosberger-Tang  <davidm@azstarnet.com>

	* src/dlh.c (env_rawhtml): New function.
	(environ_list): Use env_rawhtml.

	* dlh-inputs/slides.cls: % is comment char, not #!
	* dlh-inputs/article.cls: Ditto.
	* dlh-inputs/seminar.cls: Ditto.

Mon Jan 27 22:55:53 1997  David Mosberger-Tang  <davidm@azstarnet.com>

	* dlh-inputs/Makefile.am (pkgdata_DATA): Mention changebar.sty,
	epsfig.sty, and html.sty.

Sat Jan 25 16:12:43 1997  David Mosberger-Tang  <davidm@azstarnet.com>

	* dlh-inputs/changebar.sty: New file.

Thu Dec 12 08:09:24 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* src/dlh.c (cmd_documentclass): Fixed typo (want arg_list[0]
 	instead of arg_list[1]).
	(input_list): Fixed so it actually processes the entire list.

Wed Dec  4 22:59:30 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* src/dlh.c (eval): Skip the `-' in a soft-hyphen.

Thu Oct 17 14:19:40 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* tests/test.tex (section{Subscripts, Superscripts and the
 	Infamous Math Mode}): Change \rawhtml{} into
 	\begin{rawhtml}/\end{rawhtml} until html.sty gets updated.

Mon Oct  7 19:43:52 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* dlh-inputs/{article,slides,seminar}.cls: Make non-empty so dlh
 	doesn't whine.

Sun Sep 15 19:58:19 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* Version 0.7 released.
	
	* src/dlh.c (cmd_psfig): If verbose is in effect, print a message
 	when translating an image.

	* dlh-inputs/epsfig.sty: New style file (truly trivial).

	* src/dlh.c (main): For DLHINPUTS, take trailing colon to mean
 	"append default search list".
	(input_list): Also print warning message if verbose is in effect.
	(cmd_list): Added \sc and \textup as noop command.  \textit{} as
 	alias of {\it #1}, \textrm{} as alias of {\rm #1}, \textsc{} as
 	alias of {\sc #1}, \textsf{} as alias of {\sf #1}, \textsl{} as
 	alias of {\sl #1}.
	(filenum_bibliograph): New variable.
	(env_thebibliography): Set filenum_bibliography.
	(gen_navigation_bar): Generate References button if
 	filenum_bibliography is non-zero.

	* src/dlh.h: AUX_FORCE: new flag.
	
	* src/dlh.c (macro_eval): Check for NULL arg_list.
	(cmd_def_macro): Use strtol() instead of atoi() so we can detect
	malformed argument count.
	(eval): If `%' is not terminated by `\n', set pos to "" to avoid
	segfault.
	(filename): Initialize with "*INIT*".
	(main): Load site-start.sty at program start up if it exists.

	* src/dlh.h (strndupa): Remove extraneous closing paren.

Fri Sep 13 17:23:32 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* dlh-inputs/html.sty: Added \url{}.
	* inputs/html.sty: Ditto.

	* dlh-inputs/proc.cls: Added \copyrightspace{} (ignored).

Wed Sep  4 14:29:07 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* src/dlh.c (cmd_list): TeX \hfill is now alias for
 	\hspace{\fill}.

Mon Sep  2 16:44:39 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* src/dlh.c (cmd_symbol): New function.
	(translate_char_code): Ditto.
	(cmd_list): Added \symbol{} (LaTeX equivalent of \char).
	(cmd_documentclass): New function.
	(cmd_documentstyle): Ditto.
	(cmd_usepackage): Ditto.
	(input_list): Ditto.
	(gen_section_header): Check whether \DLHappendixtitleprefix is a
 	command, if so, evaluate it to generate the appendix title prefix
 	(used by inputs/dlh/book.cls and inputs/dlh/report.cls).
	(env_thebibliography): Evaluate \DLHbibname to generate the title
 	for the bibliography (defined by the various class files in
 	inputs/dlh).
	(cmd_list): Add default value of "References" for \DLHbibname.
	(cmd_list): Added \texttt.

	* Changed structure of dlh package: there is now a tests, inputs,
	dlh-inputs, and src directory.

	* dlh.c (gen_navigation_bar): Change table-of-contents filenumber
 	from 1 to 0.
	(main): Open table-of-contents first so it gets file number 0.
  	This fixes a bug that showed when having a cross-reference in the
 	abstract, for example.

Sun Aug 25 00:04:54 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* Version 0.6w announced.

	* lib/Makefile.am (noinst_HEADERS): Mention libiberty.h and
 	ansidecl.h.

Sat Aug 24 00:18:38 1996  David Mosberger-Tang  <davidm@burro.CS.Arizona.EDU>

	* dlh.c (tabular): Skip all @{} formats encountered within a
 	multicolumn spec, not just the last ones.

Fri Aug 23 20:19:20 1996  David Mosberger-Tang  <davidm@burro.CS.Arizona.EDU>

	* dlh.c (stopat): Don't mistake \% as %.
	(parse_arg): Ditto.
	(tabular): Print error message if \multicolumn args are malformed.
	(eval): Ignore soft hyphens (\-).
	(env_list): Remove duplicate (bogus) "math" entry.
	(mbox): New function: turn of math-mode for duration of argument
	evaluation.
	(maketitle): Evaluate title parts inside anonymous environment so
	\title{\bf foobar} works as in LaTeX.
	(gen_section_header): Starred version of sectioning command still
	needs to generate a hyperlink.
	(env_thebibliography): Generate <title> tag.
	(section): Ditto.
	(main): Ditto.
	(add_to_footnotes): Ditto.

	* dlh_math.c (math_list): Map \pm into &plusmn;

Wed Aug 21 13:26:44 1996  David Mosberger-Tang  <davidm@burro.CS.Arizona.EDU>

	* dlh.c: Make \sl synonymous to \it (better than nothing).  Make
 	\sf a no-op (there is no good substitute).

	* dlh_math.c (math_list): Add \cdot and \times.

	* dlh.h (emit): Declare.
	* dlh.c (emit): Make global

	* dlh.c (env_top_floating): Handle figure* and table*.

Tue Aug 13 15:02:56 1996  David Mosberger-Tang  <davidm@piston.cs.arizona.edu>

	* dlh.c (styledep_string): Added [STYLE_PROC] entry.
	(gen_section_header): Change style != STYLE_ARTICLE into style !=
 	STYLE_BOOK && style != STYLE_REPORT.
	(documentstyle): Recognize `proc' style (proceedings).

Mon Aug 12 21:25:56 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* Version 0.6v announced.
	
	* lib/xexit.c: New file (from FSF).
	* lib/xmalloc.c: Ditto

	* lib/Makefile.am (extra_SOURCES): Mention xmalloc.c and xexit.c.

	* icons/Makefile.am: New file (by Erick Branderhorst).

	* dlh_math.c: New file.
	* dlh_math.h: Ditto.

	* dlh.c (\mbox): Make it a macro so \mbox{\tt foobar} works like
 	in LaTeX.
	(cmd_list): Added commands \thispagestyle{} (completely ignored,
 	at this point), htmladdnormallink, htmladdnormallinkfoot, char,
 	LaTeX, TeX, thanks (some of this by Fabio Cozman).
	(env_list): Added environments: abstract, flushleft, flushright,
 	table*, math, displaymath, equation (some of this by Fabio
 	Cozman).
	(cmd_char): New function.
	(html_link): Ditto.
	(eval): Recognize \$.  Let \[, \], \(, \) be abbrevations for
 	\begin{displaymath}, \end{displaymath}, \begin{math}, and
 	\end{math}, respectively.  Give math commands preference when in
 	math mode.  Dump unknown math commands literally in output to
 	increase chance the resulting formula will be readable.  Handle
 	`$' (toggle math-mode), `_' (subscript), and `^' (superscript).
	(main): Call math_init(). Also case f[0].

Tue Jul 30 19:50:23 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* dlh.c (tpage): Added THANKS member.
	(main): Call xmalloc_set_program_name().
	Add include of <libiberty.h>.
	Replace calls to malloc()/realloc() with calls to
	xmalloc()/xrealloc() and elide out-of-memory checking.

	* Makefile.am (test): Let make ignore errors during latex/dvips.

Fri Jul 19 09:15:15 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* Version 0.6 released.
	
	* dlh.c: Include <libintl.h> only if ENABLE_NLS is true.
	(enum Style): New type enumerating document styles.
	(style): New variable holding current document style.
	(appendix_level): New variable: holds sectioning-level at which
 	appendices occur when inside the appendix.
	(styledep_strings): Array holding strings that are
 	style-dependent.
	(make_current_section_number_string): Use letters for section
 	"number" at the appendix level.
	(env_thebibliography): Use styledep_strings[0] instead of
 	hard-coded "References" as the bibliography heading.
	(gen_section_header): Typeset appendix headings like LaTeX (i.e.,
 	when not in article-style, set "Appendix L" separately from the
 	appendix title).
	(appendix): New function.
	(documentstyle): New function.
	(cmd_list): Change documentclass/documentstyle to call
 	documentstyle.

Fri Jul 12 02:02:09 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* dlh.c (cmd_list): Added \noindent.
	(section): Added support for *-form of sectioning commands.
	(main): Create symlink from DIRPREFIX/doc000.html to
 	DIRPREFIX/index.html.

	* config.h.in: Add ssize_t.
	* configure.in: Check for ssize_t.

Thu Jul 11 00:42:48 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* Version 0.5 released.
	
	* dlh.h (struct xref_def): Renamed from label_def.
	(struct xref_use): Renamed from label_use.
	(struct xref_tab): Renamed from label_tab.

	* dlh.c (open_file): Do not attempt to mmap() more than FILE_SIZE
 	bytes.  DEC Unix is picky about this and will not allow such a
 	request.  Instead, simply write an addition NUL byte if necessary
	(which also means that it may be necessary to mmap another page).
  	Get rid of bogus <body> tags.
	(maketitle): Don't assume all title page fields have been defined.
	(cmd_list): Removed \cr---it's a TeX command and didn't work as
 	expected anyhow.  Use \\ instead.
	(cmd_list): Added \emph{} and \textbf{} (LaTeX 2e).
	(cmd_list): Added \P (paragraph sign) and \S (section sign).
  	Contributed by Peter Junger.
	(env_list): Added quotation (treated like quote, for now).
	(cmd_list): Added \bibitem[]{}, \cite[]{}, \nocite{}.
	(env_thebibliography): New function.
	(bibitem): Ditto.
	(cite): Ditto.

Wed Jul 10 01:03:32 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* Version 0.4 released.
	
	* dlh.c, dlh.h: Renamed from sdoc2html.

	* sdoc2html.c (dtab): New hash table for dimensions (lengths).
	(dim_list): New array holding initial dimensions.
	(cmd_list): New macos: bigskip, medskip, smallskip.  New commands:
	\cr, \par, \vspace*, \hspace*.
	(settowidth): New function.
	(addtolength): Ditto.
	(setlength): Ditto.
	(newlength): Ditto.
	(env_list): Added flushleft and flushright environments.  They're
	no-ops, for now.
	Marked all strings for internationalization support (based on patch
	by Erick Branderhorst).

	* Version 0.3 released.
	
	* sdoc2html.c (usage): Document commandline options.
	(opts, main): Add --help, --verbose, and --icon-dir options.

Tue Jul  9 22:12:35 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* sdoc2html.c (eval): Recognize \& as an ampersand.
	(space): New function.
	(cmd_list): Add vspace and hspace support using space() function.

Thu Jul  4 00:23:10 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* sdoc2html.c: Initialize icon_dir with "../icons" which is more
 	useful than an absolute path.
	(gen_index): Use two-column format for index (requies Netscape
 	3.x).

Tue Jul  2 14:55:20 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* Version 0.2 released.
	
	* sdoc2html.c: Also print linenumber of input file in error
 	messages.

Thu Jun 27 21:29:01 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* sdoc2html.c: Added support for \newcommand and \newenvironment.
	(psfig): Use PostScript's `run' command to avoid having to
 	distribute showpage.ps.

Sat Jun 22 17:28:48 1996  David Mosberger-Tang  <davidm@azstarnet.com>

	* sdoc2html.c (make_index): Print only one instances of multiple,
 	identical index entries.

%prep
rm -fr $RPM_BUILD_ROOT
%setup
%patch -p1

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr
make

%install
mkdir -p $RPM_BUILD_ROOT/usr/include \
        $RPM_BUILD_ROOT/usr/lib \
        $RPM_BUILD_ROOT/usr/bin

make prefix=$RPM_BUILD_ROOT/usr install

%clean
rm -rf $RPM_BUILD_ROOT

%files
/usr/bin/dlh
/usr/man/man1/dlh.1
/usr/share/dlh/icons/contents.gif
/usr/share/dlh/icons/index.gif
/usr/share/dlh/icons/next.gif
/usr/share/dlh/icons/previous.gif
/usr/share/dlh/icons/up.gif
/usr/share/dlh/icons/next_gr.gif
/usr/share/dlh/icons/previous_gr.gif
/usr/share/dlh/icons/up_gr.gif
/usr/share/dlh/icons/references.gif
/usr/share/dlh/inputs/html.sty
/usr/share/dlh/inputs/dlh/article.cls
/usr/share/dlh/inputs/dlh/book.cls
/usr/share/dlh/inputs/dlh/letter.cls
/usr/share/dlh/inputs/dlh/proc.cls
/usr/share/dlh/inputs/dlh/report.cls
/usr/share/dlh/inputs/dlh/seminar.cls
/usr/share/dlh/inputs/dlh/slides.cls
/usr/share/dlh/inputs/dlh/changebar.sty
/usr/share/dlh/inputs/dlh/epsfig.sty
/usr/share/dlh/inputs/dlh/html.sty
